#include "assign3.h"


// Deconctructor delets pointers created
student::~student()
{
	cout << endl << studentName << " Status : " << studentStatus;
	if (studentStatus == 'E')
	{
		cout << " Performing Delete";
		if (grade)
			delete [] grade;
		if (courseId)
			delete [] courseId;
	}
	else
	{
		cout << " Calling Deconstructor";
	}
}


// Constructor which copyes input from user in varable and set's the rest to default values
student::student(char stName[20])
{
	strcpy(studentName, stName);
	studentStatus = 'N';
	numCourses = 0;
}


// Second constructor which dose the same thing as the first but this one stores memory
// for the vairable during execution

student::student(char stName[20], int stuCourses)
{
	strcpy(studentName, stName);
	studentStatus = 'E';
	numCourses = stuCourses;
	courseId = new int[stuCourses];
	grade = new char[stuCourses];
	setCourseInfo();
}



// Changes the stauts of the student
void student::changeStatus(short newCourses)
{
	studentStatus = 'E';
	numCourses = newCourses;
	courseId = new int[newCourses];
	grade = new char[newCourses];
	cout << endl << "Changing status to Enrolled for: " << studentName << endl;
	setCourseInfo();
}


// Sets the course information for the user and dose valadiation aswell
// to insure that the values are correct

void student::setCourseInfo()
{
	cout << endl << "Enter course infomation for: " << studentName << endl;
	cout << "Enter " << numCourses << " courses:" << endl;

	for (int i = 0; i < numCourses; i++)
	{
		bool flag = false;
		cout << "Enter the Course Id : ";
		cin >> courseId[i];
		cin.ignore();
		while (!flag)
		{
			for (int j = 0; j < 4; j++)
			{
				if (courseId[i] == courseNum[j])
				{
					flag = true;
					cout << "Enter the Grade : ";
					cin >> grade[i];
					cin.ignore();
					break;
				}
			}
			if (!flag)
			{
				cout << "Invalid id. re-enter the course id : ";
				cin >> courseId[i];
				cin.ignore();
			}
		}
	}
}


// Displays the student information
void student::showStudentInfo()
{
	cout << endl << "Student Name: " << studentName << endl;
	cout << "Status: " << studentStatus << endl;
}


// Displays the course information for each student
void student::showCourseInfo()
{
	cout << endl << "Displaying Course Info for " << studentName << endl;
	if (studentStatus == 'E')
	{
		cout << "Course\tGrade" << endl;
		for (int i= 0; i < numCourses; i++)
		{
			cout << courseName[i] << "\t" << grade[i] << endl;
		}
	}
	else
	{
		cout << "Student not Enrolled" << endl;
	}
}


//main program
int main()
{
	student *StudentPointer[3];
	StudentPointer[0] = new student("Sam Brown", 1);

	StudentPointer[0]->showStudentInfo();
	StudentPointer[0]->showCourseInfo();


	student student1 = student("Mary Brown");
	student student2 = student("Jo Ho", 2);
	student student3 = student("Juan Li");

	student1.changeStatus(4);

	student1.showStudentInfo();
	student1.showCourseInfo();

	student2.showStudentInfo();
	student2.showCourseInfo();

	student3.showStudentInfo();
	student3.showCourseInfo();

	delete StudentPointer[0];

	cout << endl;

	return 0;
}
